git repack: keep commits hidden by a graft
[git/git.git] / git-repack.sh
CommitLineData
b2d46199 1#!/bin/sh
ccf1ee32
JH
2#
3# Copyright (c) 2005 Linus Torvalds
4#
5
5715d0bb
PH
6OPTIONS_KEEPDASHDASH=
7OPTIONS_SPEC="\
1b1dd23f 8git repack [options]
5715d0bb
PH
9--
10a pack everything in a single pack
ca11b212 11A same as -a, and turn unreachable objects loose
5715d0bb 12d remove redundant packs, and run git-prune-packed
8d11fdea 13f pass --no-reuse-object to git-pack-objects
2b36b146 14n do not run git-update-server-info
5715d0bb
PH
15q,quiet be quiet
16l pass --local to git-pack-objects
17 Packing constraints
18window= size of the window used for delta compression
19window-memory= same as the above, but limit memory size instead of entries count
20depth= limits the maximum delta depth
21max-pack-size= maximum size of each packfile
22"
d0b353b1 23SUBDIRECTORY_OK='Yes'
ae2b0f15 24. git-sh-setup
ccb36504 25
ca11b212 26no_update_info= all_into_one= remove_redundant= unpack_unreachable=
479b56ba 27local= quiet= no_reuse= extra=
822f7c73 28while test $# != 0
ccf1ee32
JH
29do
30 case "$1" in
31 -n) no_update_info=t ;;
d5acdcf1 32 -a) all_into_one=t ;;
65aa5302 33 -A) all_into_one=t
ca11b212 34 unpack_unreachable=--unpack-unreachable ;;
0adb3358 35 -d) remove_redundant=t ;;
cec2be76 36 -q) quiet=-q ;;
479b56ba 37 -f) no_reuse=--no-reuse-object ;;
cec2be76 38 -l) local=--local ;;
5715d0bb
PH
39 --max-pack-size|--window|--window-memory|--depth)
40 extra="$extra $1=$2"; shift ;;
41 --) shift; break;;
9678faaa 42 *) usage ;;
ccf1ee32
JH
43 esac
44 shift
45done
46
22c79eab 47case "`git config --bool repack.usedeltabaseoffset || echo true`" in
b6945f57
JH
48true)
49 extra="$extra --delta-base-offset" ;;
50esac
51
d5acdcf1 52PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
6b94b1a0 53PACKTMP="$GIT_OBJECT_DIRECTORY/.tmp-$$-pack"
0ea2582d
ML
54rm -f "$PACKTMP"-*
55trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
d5acdcf1
JH
56
57# There will be more repacking strategies to come...
58case ",$all_into_one," in
59,,)
cd0d74d2 60 args='--unpacked --incremental'
d5acdcf1
JH
61 ;;
62,t,)
2478dc84 63 args= existing=
ce859074
SP
64 if [ -d "$PACKDIR" ]; then
65 for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
66 | sed -e 's/^\.\///' -e 's/\.pack$//'`
67 do
68 if [ -e "$PACKDIR/$e.keep" ]; then
69 : keep
70 else
ce859074
SP
71 existing="$existing $e"
72 fi
73 done
171110a4 74 if test -n "$existing" -a -n "$unpack_unreachable" -a \
83d0289d 75 -n "$remove_redundant"
f7991d1e
BC
76 then
77 args="$args $unpack_unreachable"
78 fi
65aa5302 79 fi
d5acdcf1
JH
80 ;;
81esac
0ea2582d 82
479b56ba 83args="$args $local $quiet $no_reuse$extra"
7f3140cd 84names=$(git pack-objects --keep-true-parents --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
b2d46199 85 exit 1
6b94b1a0 86if [ -z "$names" ]; then
d9fb395a
UKK
87 if test -z "$quiet"; then
88 echo Nothing new to pack.
89 fi
6b94b1a0 90fi
d5acdcf1 91
3e6b1d0a
JH
92# Ok we have prepared all new packfiles.
93mkdir -p "$PACKDIR" || exit
94
95# First see if there are packs of the same name and if so
96# if we can move them out of the way (this can happen if we
97# repacked immediately after packing fully.
98rollback=
99failed=
100for name in $names
101do
2ad47d61
JH
102 for sfx in pack idx
103 do
3e6b1d0a
JH
104 file=pack-$name.$sfx
105 test -f "$PACKDIR/$file" || continue
106 rm -f "$PACKDIR/old-$file" &&
107 mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
108 failed=t
109 break
110 }
111 rollback="$rollback $file"
112 done
113 test -z "$failed" || break
114done
115
116# If renaming failed for any of them, roll the ones we have
117# already renamed back to their original names.
118if test -n "$failed"
119then
120 rollback_failure=
121 for file in $rollback
122 do
123 mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
124 rollback_failure="$rollback_failure $file"
125 done
126 if test -n "$rollback_failure"
127 then
128 echo >&2 "WARNING: Some packs in use have been renamed by"
129 echo >&2 "WARNING: prefixing old- to their name, in order to"
130 echo >&2 "WARNING: replace them with the new version of the"
131 echo >&2 "WARNING: file. But the operation failed, and"
132 echo >&2 "WARNING: attempt to rename them back to their"
133 echo >&2 "WARNING: original names also failed."
134 echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
135 for file in $rollback_failure
136 do
137 echo >&2 "WARNING: old-$file -> $file"
138 done
139 fi
140 exit 1
141fi
142
143# Now the ones with the same name are out of the way...
144fullbases=
145for name in $names
146do
147 fullbases="$fullbases pack-$name"
148 chmod a-w "$PACKTMP-$name.pack"
149 chmod a-w "$PACKTMP-$name.idx"
0ea2582d 150 mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
3e6b1d0a
JH
151 mv -f "$PACKTMP-$name.idx" "$PACKDIR/pack-$name.idx" ||
152 exit
153done
154
155# Remove the "old-" files
156for name in $names
157do
158 rm -f "$PACKDIR/old-pack-$name.idx"
159 rm -f "$PACKDIR/old-pack-$name.pack"
6b94b1a0 160done
d5acdcf1 161
3e6b1d0a
JH
162# End of pack replacement.
163
0adb3358 164if test "$remove_redundant" = t
d5acdcf1 165then
ce859074
SP
166 # We know $existing are all redundant.
167 if [ -n "$existing" ]
62af0b53 168 then
6ed64058
JH
169 ( cd "$PACKDIR" &&
170 for e in $existing
171 do
dca3957b
DH
172 case " $fullbases " in
173 *" $e "*) ;;
ce859074 174 *) rm -f "$e.pack" "$e.idx" "$e.keep" ;;
62af0b53 175 esac
6ed64058
JH
176 done
177 )
d5acdcf1 178 fi
5be60078 179 git prune-packed $quiet
d5acdcf1 180fi
ccf1ee32 181
ccf1ee32
JH
182case "$no_update_info" in
183t) : ;;
e1dc49bc 184*) git update-server-info ;;
ccf1ee32 185esac